package unicrawler.crawler;

import java.util.concurrent.ScheduledThreadPoolExecutor;

import org.apache.log4j.Logger;

public class CrawlerMonitor implements Runnable {

	private ScheduledThreadPoolExecutor mPool;
	private CrawlerWorkerCounter mCounter;
	
	private Logger logger = Logger.getLogger(CrawlerMonitor.class.getName());
	
	@Override
	public void run() {
		try {
			do {
				logger.debug(String.format("\r\nPool size: %d\r\nActive Crawlers: %d\r\nCompleted: %d",
						this.mPool.getCorePoolSize(),
						this.mCounter.getNumOfCrawlers(),
						this.mPool.getCompletedTaskCount()
					)
				);
				
				Thread.sleep(1000);	// 15seconds, this blocks at the end of execution though
			} while (this.mCounter.getNumOfCrawlers() != 0);
		} catch (InterruptedException e) {
			// TODO Auto-generated catch block
			logger.error("Crawler monitor thread died!");
			e.printStackTrace();
		}
		finally {
			logger.info("Pool is shutting down now...");
			this.mPool.shutdown();
		}
	}

	public CrawlerMonitor(ScheduledThreadPoolExecutor _pool, CrawlerWorkerCounter _counter) {
		this.mPool = _pool;
		this.mCounter = _counter;
	}
}
