package unicrawler.types;

import java.net.MalformedURLException;
import java.net.URL;

/*
 * Class to handle a given URL -- holds information such as crawled depth etc
 */
public class CrawlerURL {

	 private String mLink = "";
	 private int mDepth = 0;
	 
	 public CrawlerURL(String _link, int _depth) {
		 this.mLink = _link;
		 this.mDepth = _depth;
	 }
	 
	 public URL getAsObject() throws MalformedURLException {
		 return new URL(this.mLink);
	 }
	 
	 public String getDomain() {
		 try {
			 return this.getAsObject().getHost();
		 }
		 catch (MalformedURLException ex) {
			 // do nothing
		 }
		 
		 return null;
	 }
	 
	 public int getDepth() {
		 return this.mDepth;
	 }
	 
	 public String getLink() {
		 return this.mLink;
	 }
}
