package unicrawler.utils;

import java.io.FileInputStream;
import java.util.Properties;

/*
 * Load properties from our crawler.properties file.
 * Options to override values if not found within properties file with default vals.
 */
public class PropertiesFile {

	private Properties props;
	
	public PropertiesFile() {
		this.props = new Properties();
	}
	
	public boolean loadPropertyFile(String path) {
		try {
			this.props.load(new FileInputStream(path));
			return true;
		}
		catch (Exception ex) {
			// todo log
			return false;
		}
	}
	
	public String get(String propertyName, String defaultValue) {
		return this.props.getProperty(propertyName, defaultValue);
	}
	
	public String get(String propertyName) {
		return this.get(propertyName, null);
	}
	
	public int getInt(String propertyName, int defaultValue) {
		try {
			return Integer.parseInt(this.get(propertyName));
		}
		catch (NumberFormatException ex) {
			return defaultValue;
		}
	}
	
	public int getInt(String propertyName) {
		return this.getInt(propertyName);
	}
	
	public int size() {
		return this.props.size();
	}
}
